% vdp0.m
% integration de     dx/dt +  y = 0 ,     dy/dt -  x = 0 
%                          par LE Runge Kutta d ordre 4
% la solution exacte est   x =  cost ,    y = sint   !!!
% fd, iacs, 26 mai, 08 juillet, 18 septembre  2004
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('Cycle limite avec Le fameux schema de Runge et Kutta d ordre quatre.') ;
title ('Cnam Paris. Travaux pratiques Iacs.') ;
n=400;  dt=2*pi/n
vec=zeros(2,2) ; 
x=1;
y=0;
gset yrange[-1.1:1.1] ; gset xrange[-1.1: 1.1] ; 
  for i=1:n;
if i<=1 ;   hold off ; plot(x , y, '*g;depart;') ; end  ; 
px1 = -  y                         ; py1 =   x ; 
px2 = - ( y + 0.5 * dt * py1 )  ; py2 =  ( x + 0.5 * dt * px1 ) ; 
px3 = - ( y + 0.5 * dt * py2 )  ; py3 =  ( x + 0.5 * dt * px2 ) ; 
px4 = - ( y + dt * py3 )  ;       py4 =  ( x + dt * px3 ) ; 
xn  = x + dt * ( px1 + 2*px2 + 2*px3+ px4  ) / 6 ;
yn  = y + dt * ( py1 + 2*py2 + 2*py3+ py4  ) / 6 ;
%
vec(1,1)=x ; vec(2,1)=xn ; 
vec(1,2)=y ; vec(2,2)=yn ; 
if i<=1 ;   
hold on ; plot ( vec(:,1) , vec(:,2), 'r;trajectoire;') ; else ; 
plot ( vec(:,1) , vec(:,2), 'r;;') ; end ; 
x=xn ; y=yn ; 
end ;
hold on ;  plot(xn , yn , '*b;arrivee;') ; 
un = xn
nul = yn
