% vdpco3.m
% integration de     dx/dt =  y + x - x**3 , dy/dt =  -x
% par les schemas d Euler expli, Euler impli,
%       Crank-Nicolson,  Heun et Runge Kutta
% la solution exacte est l attracteur de Van der Pol
% fd, iacs, 18 septembre 2004, 2, 16 janvier 2005, 22 janvier 2006.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('vdpco3. Cycle limite non lineaire avec cinq  schemas.') ;
title ('Oscillateur de Van der Pol') ;
n=8;  dt=1/n
xe=zeros(2,1);
xe(1,1)=0.1  ;  xe(2,1)=0 ; xi=xe ; xcn=xe ;  xhe=xe ; xrk=xe ;
vece=zeros(2,2); veci=zeros(2,2); vecn=zeros(2,2); vecrk=zeros(2,2);
% gset yrange[-0.7:1.5] ; gset xrange[-1: 1] ; 
axis ([ -1 , 1 ,  -.7 , 1.5 ]) 
for i=1:6*n;
if i<=1 ;   hold off ; plot( xe(1,1) , xe(2,1) , '*g;depart;') ; end  ; 
xne  = xe + dt * f(xe) ;   
xni  = er(xi,dt) ;  xncn  = cn(xcn,dt) ;
xnhe = he(xhe,dt) ; xnrk  = rk(xrk,dt) ;
vece(1,1)=xe(1,1) ; vece(2,1)=xne(1,1) ; 
vece(1,2)=xe(2,1) ; vece(2,2)=xne(2,1) ; 
veci(1,1)=xi(1,1) ; veci(2,1)=xni(1,1) ; 
veci(1,2)=xi(2,1) ; veci(2,2)=xni(2,1) ; 
vecn(1,1)=xcn(1,1) ; vecn(2,1)=xncn(1,1) ; 
vecn(1,2)=xcn(2,1) ; vecn(2,2)=xncn(2,1) ; 
veche(1,1)=xhe(1,1) ; veche(2,1)=xnhe(1,1) ; 
veche(1,2)=xhe(2,1) ; veche(2,2)=xnhe(2,1) ; 
vecrk(1,1)=xrk(1,1) ; vecrk(2,1)=xnrk(1,1) ; 
vecrk(1,2)=xrk(2,1) ; vecrk(2,2)=xnrk(2,1) ; 
hold on ; 
if i<=1 ; hold on ; 
plot ( vece(:,1) , vece(:,2), 'r;trajectoire expli;') ; 
plot ( veci(:,1) , veci(:,2), 'ob;trajectoire impli;') ; 
plot ( vecn(:,1) , vecn(:,2), '*g;trajectoire CN;') ; 
plot ( veche(:,1) , veche(:,2), 'om;trajectoire Heun;') ; 
plot ( vecrk(:,1) , vecrk(:,2), 'or;Runge Kutta ordre 4;') ; else ;
plot ( vece(:,1) , vece(:,2), 'r;;') ; 
plot ( veci(:,1) , veci(:,2), 'ob;;') ; 
plot ( vecn(:,1) , vecn(:,2), '*g;;') ;
plot ( veche(:,1) , veche(:,2), 'om;;') ; 
plot ( vecrk(:,1) , vecrk(:,2), 'or;;') ; end ;
xe=xne ; xi=xni ;  xcn=xncn   ;  xhe=xnhe   ;    xrk=xnrk   ;  end ; 
plot ( xe(1,1) , xe(2,1), '*r;arrivee expli;')  ;
plot ( xi(1,1) , xi(2,1), '*b;arrivee impli;') ; 
plot ( xcn(1,1) , xcn(2,1), '*g;arrivee CN;') ; 
plot ( xhe(1,1) , xhe(2,1), '*m;arrivee Heun;') ;
plot ( xrk(1,1) , xrk(2,1), '*r;arrivee du Runge Kutta d xordre 4;') ; hold off ;
