% vdpee.m
% integration de     dx/dt =  y + x - x**3   ,     dy/dt =  -x
%                          par un schema d Euler
% la solution exacte est l attracteur de Van der Pol
% fd, iacs, 18 septembre 2004, 2, 16 janvier 2005
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('vdpee. Cycle limite non lineaire avec le schema d Euler explicite.') ;
title ('Oscillateur de Van der Pol') ;
n=25;  dt=1/n
vec=zeros(2,2) ; x=zeros(2,1) ; 
x(1,1)=0.1;    x(2,1)=0;
% gset yrange[-1.1:1.1] ; gset xrange[-1.1: 1.1] ; 
% gset yrange[-1:1.3] ; gset xrange[-1: 1] ; 
axis ([ -1 , 1 ,  -1 , 1.3 ]) 
for i=1:6*n;
if i<=1 ;   hold off ; plot(x(1,1) , x(2,1) , '*g;depart;') ; end  ; 
xn  = x + dt * f(x) ;
%
vec(1,1)=x(1,1) ; vec(2,1)=xn(1,1) ; 
vec(1,2)=x(2,1) ; vec(2,2)=xn(2,1) ; 
if i<=1 ;   
hold on ; plot ( vec(:,1) , vec(:,2), 'r;trajectoire;') ; else ; 
plot ( vec(:,1) , vec(:,2), 'or;;') ; end ; 
x=xn ;     end ; 
hold on ;  plot(xn(1,1) , xn(2,1) , '*b;arrivee;') ; hold off ;
